(function() {
  var AssertionError, Log, assert, async, autoSpec, autospec, checkPaths, coffee, colorize, config, displayNotification, errors, exec, expresso, failures, file_matcher, files, fs, gatherFiles, getVersion, growl, handleError, hook_stdout, http, intialTestComplete, libDir, log, main, path, prodCoffeeFiles, prodCoffeeOpts, prodDeployDir, prodSrcDir, report, request, requestCount, rootDir, runTestFile, runTestSuite, runTests, showVersion, spec, specCoffeeFiles, specCoffeeOpts, specFileDir, stalker, startHeader, sys, testcount, tester, unWatchCoffeeFile, unhook, util, walk, watchCoffeeFile, writeSpecFile, _ref, _ref2, _ref3;
  exec = require('child_process').exec;
  assert = require('assert');
  async = require('async');
  coffee = require('coffee-script');
  errors = [];
  fs = require('fs');
  growl = require('growl');
  http = require('http');
  Log = require('coloured-log');
  path = require('path');
  request = require('request');
  stalker = require('stalker');
  sys = require('sys');
  util = require('util');
  config = (function() {
    try {
      return require("" + rootDir + "/kitkat.config.js");
    } catch (_e) {}
  })();
  config = config != null ? config : config = {
    noConfig: true,
    noCompile: true,
    safetyOff: false
  };
  log = new Log();
  libDir = path.join(path.dirname(fs.realpathSync(__filename)), '../lib');
  rootDir = process.cwd();
  autoSpec = false;
  expresso = path.join(path.dirname(fs.realpathSync(__filename)), '../bin/expresso spec/*.coffee -I lib');
  file_matcher = /\.(js|coffee)$/;
  intialTestComplete = false;
  prodDeployDir = path.join("" + rootDir, (_ref = config.prodDeployDir) != null ? _ref : config.prodDeployDir = "lib");
  prodSrcDir = path.join("" + rootDir, (_ref2 = config.prodSrcDir) != null ? _ref2 : config.prodSrcDir = "src");
  specFileDir = path.join("" + rootDir, (_ref3 = config.specFileDir) != null ? _ref3 : config.specFileDir = "spec");
  prodCoffeeFiles = [];
  specCoffeeFiles = [];
  failures = 0;
  testcount = 0;
  requestCount = 0;
  files = [];
  prodCoffeeOpts = "--output " + prodDeployDir;
  specCoffeeOpts = "--output " + specFileDir;
  if (config.noCompile === true) {
    require.paths.unshift("" + prodSrcDir);
  } else {
    require.paths.unshift("" + prodDeployDir);
  }
  hook_stdout = function(callback) {
    var old_write;
    old_write = process.stdout.write;
    process.stdout.write = (function(write) {
      return function(string, encoding, fd) {
        if (string.match(/!!!/)) {
          string = string.replace("!!!", "");
          write.apply(process.stdout, arguments);
        }
        return callback(string, encoding, fd);
      };
    })(process.stdout.write);
    return function() {
      return process.stdout.write = old_write;
    };
  };
  unhook = null;
  process.on("uncaughtException", function(err) {
    return log.emergency("Uncaught Exception:  " + err);
  });
  checkPaths = function(callback) {
    if (config.safetyOff) {
      return callback(null);
    } else {
      return path.exists(prodDeployDir, function(exists) {
        if (!exists && config.noCompile === false) {
          log.warning("The lib path was not found, this has been created.");
          exec("mkdir " + prodDeployDir, function(err, stdout, stderr) {
            if (err) {
              return callback(err);
            }
          });
        }
        return path.exists(specFileDir, function(exists) {
          if (!exists) {
            log.warning("The spec path was not found, this has been created.");
            exec("mkdir " + specFileDir, function(err, stdout, stderr) {
              if (err) {
                return callback(err);
              }
            });
          }
          return path.exists(prodSrcDir, function(exists) {
            if (!exists) {
              return exec("mkdir " + prodSrcDir, function(err, stdout, stderr) {
                if (err) {
                  return callback(err);
                } else {
                  log.warning("The src path was not found, this has been created and a default app.coffee file created.");
                  return exec("touch " + prodSrcDir + "/app.coffee", function(err, stdout, stderr) {
                    if (!config.noCompile === true) {
                      log.notice("Compiling lib/app.js from default app.coffee");
                      return exec("coffee --output " + prodDeployDir + " --compile " + prodSrcDir + "/app.coffee", function(err, stdout, stderr) {
                        return callback(err);
                      });
                    } else {
                      return callback(err);
                    }
                  });
                }
              });
            } else {
              return callback(null);
            }
          });
        });
      });
    }
  };
  getVersion = function(callback) {
    return fs.readFile(path.join(path.dirname(fs.realpathSync(__filename)), "../package.json"), function(err, data) {
      var package;
      if (err) {
        throw err;
      }
      package = JSON.parse(data);
      return callback(package);
    });
  };
  showVersion = function(argv) {
    return getVersion(function(package) {
      return log.info(colorize("[purple]{Kitkat - " + package.version + "}"));
    });
  };
  startHeader = function(action) {
    log.notice(colorize("[purple]{Kitkat - Kontinuous Integrated Testing Koffee Application Template}"));
    log.notice(colorize("[red]{press CTRL-C to quit}\n\n"));
    if (config.noCompile === false) {
      log.notice(colorize("[bold]{noCompile:} false - This means you are creating .js files in " + prodDeployDir));
    }
    if (config.safetyOff === true) {
      log.notice(colorize("[bold]{safetyOff:} True"));
    }
    log.notice("" + action);
    log.notice(colorize("[bold]{source files:} " + prodSrcDir));
    return log.notice(colorize("[bold]{spec files:} " + specFileDir + "\n"));
  };
  exports.run = function() {
    var args, command, commands, key, optimist, value, _ref4;
    optimist = require('optimist');
    args = optimist.argv;
    optimist.alias('test', 't');
    optimist.alias('spec', 's');
    optimist.alias('autospec', 'a');
    optimist.alias('version', 'v');
    optimist.usage(colorize("[purple]{Kitkat - Kontinuous Integrated Testing Koffee Application Template}\n\n [bold]{Default usage} - with no arguments, it will monitor the current project for changes and\n\t\t run all spec files found against all coffee files found."), {
      'test': {
        description: colorize("[green]{runs all tests against your application files in the spec path\n}"),
        required: false
      },
      'spec': {
        description: colorize("[green]{generates spec files based on the supplied path/file, if none\n\t\t  provided then processes all coffee files in project\n}"),
        required: false
      },
      'autospec': {
        description: colorize("[green]{generates new spec files and monitors all files for changes,\n\t\t  automatically runs tests on startup and as files change\n}"),
        required: false
      },
      'version': {
        description: colorize("[green]{displays version number for kitkat}"),
        required: false
      }
    });
    commands = [];
    for (key in args) {
      value = args[key];
      try {
        switch (key.toLowerCase()) {
          case "t":
          case "test":
          case "s":
          case "spec":
          case "a":
          case "autotest":
          case "v":
          case "version":
            commands.push(key);
            break;
          default:
            if (key !== "$0" && key !== "_") {
              throw "Invaid argument";
            }
        }
      } catch (ex) {
        log.error("" + ex + "\n");
        optimist.showHelp();
        return;
      }
    }
    command = (_ref4 = commands[0]) != null ? _ref4.toLowerCase() : void 0;
    if (command !== 'v' && command !== 'version') {
      return checkPaths(function(err) {
        var _ref5;
        if (err) {
          handleError(err);
          callback(err);
        }
        switch (command) {
          case "t":
          case "test":
            startHeader("Initiating tests");
            return tester();
          case "s":
          case "spec":
            startHeader("Generating spec files");
            return spec((_ref5 = args.s) != null ? _ref5 : args.s = args.spec);
          case "a":
          case "autospec":
            startHeader("Autospec and testing current project");
            return autospec();
          default:
            startHeader("Monitoring and testing current project");
            return main();
        }
      });
    } else {
      return showVersion();
    }
  };
  assert.AssertionError = AssertionError = function(options) {
    this.message = options.message;
    this.actual = "";
    this.expected = "";
    if (options.actual != null) {
      this.actual = "\n[bold]{Actual:} [red]{" + options.actual + "}";
    }
    if (options.expected != null) {
      this.expected = "\n[bold]{Expected:} [green]{" + options.expected + "}";
    }
    return log.error(colorize("!!![red]{Test failed}\n\nMessage: [bold]{" + this.message + "}\n" + this.actual + this.expected + "\nFailures: " + failures + "\n\n[bold]{================================================================}\n"));
  };
  util.inherits(assert.AssertionError, Error);
  assert.response = function(server, req, res, msg) {
    var requestFailures, url;
    requestCount++;
    requestFailures = 0;
    url = "";
    if (req.secure === true) {
      url += "https://";
    } else {
      url += "http://";
    }
    url += "" + (server.address().address) + ":" + (server.address().port) + req.url;
    return request({
      uri: url
    }, function(error, response, body) {
      var actual, eql, expected, i, keys, len, name, _results;
      requestCount--;
      if (res.body !== void 0) {
        eql = (res.body instanceof RegExp ? res.body.test(response.body) : res.body === response.body);
        try {
          assert.ok(eql, colorize("" + (msg()) + "[red]{Invalid response body.}\n\n[bold]{Actual:} Please review [red]{" + url + "}\n[bold]{Expected:} [green]{" + (sys.inspect(res.body)) + "}\n"));
        } catch (err) {
          if (++requestFailures <= 1) {
            failures++;
          }
        }
      }
      if (typeof response.statusCode === "number") {
        try {
          if (typeof res['status'] === "number") {
            assert.equal(response.statusCode, res['status'], colorize("" + (msg()) + "[red]{Invalid response status code.}"));
          }
        } catch (err) {
          if (++requestFailures <= 1) {
            failures++;
          }
        }
      }
      if (res.headers) {
        keys = Object.keys(res.headers);
        i = 0;
        len = keys.length;
        _results = [];
        while (i < len) {
          name = keys[i];
          actual = response.headers[name.toLowerCase()];
          expected = res.headers[name];
          eql = (expected instanceof RegExp ? expected.test(actual) : expected === actual);
          try {
            assert.equal(actual, expected, colorize("" + (msg()) + "[red]{Invalid response header}"));
          } catch (err) {
            if (++requestFailures <= 1) {
              failures++;
            }
          }
          _results.push(++i);
        }
        return _results;
      }
    });
  };
  autospec = function() {
    autoSpec = true;
    return main();
  };
  coffee = function(options, file) {
    if (options == null) {
      options = "";
    }
    log.info("Compiling " + file);
    return exec("coffee " + options + " --compile " + file, function(err, stdout, stderr) {
      if (err) {
        return handleError(err);
      }
    });
  };
  colorize = function(str) {
    var colors;
    colors = {
      bold: 1,
      red: 31,
      green: 32,
      yellow: 33,
      purple: 35,
      cyan: 36
    };
    return str.replace(/\[(\w+)\]\{([^]*?)\}/g, function(_, color, str) {
      return "\u001b[" + colors[color] + "m" + str + "\u001b[0m";
    });
  };
  displayNotification = function(message) {
    var options;
    if (message == null) {
      message = '';
    }
    options = {
      title: 'CoffeeScript',
      image: 'lib/CoffeeScript.png'
    };
    return growl.notify(message, options);
  };
  gatherFiles = function(filepath, extRegex, callback) {
    var file, filesFound;
    filesFound = [];
    file = path.normalize(filepath);
    return fs.stat(file, function(err, stats) {
      if (err) {
        file += extRegex.toString().replace(/\//g, "").replace(/\\/g, "");
        return fs.stat(file, function(err, stats) {
          if (err) {
            callback(err, null);
          }
          if (!err) {
            filesFound.push(file);
            return callback(null, filesFound);
          }
        });
      } else {
        if (stats.isDirectory()) {
          return walk(path.normalize(file + '/'), extRegex, function(err, results) {
            if (err) {
              callback(err, null);
            }
            if (!err) {
              filesFound = results;
              return callback(null, filesFound);
            }
          });
        } else {
          filesFound.push(file);
          return callback(null, filesFound);
        }
      }
    });
  };
  handleError = function(error) {
    log.error(error);
    return displayNotification(error);
  };
  main = function() {
    stalker.watch("" + prodSrcDir, watchCoffeeFile, unWatchCoffeeFile);
    stalker.watch("" + specFileDir, watchCoffeeFile, unWatchCoffeeFile);
    return tester();
  };
  report = function(title) {
    var message, options, status;
    log.notice("" + failures);
    status = 'green';
    message = "";
    options = {};
    sys.print(colorize("[bold]{\n=======================================================================================\nTesting of '" + title + "' completed.\n\n}"));
    if (failures) {
      status = 'red';
      options = {
        title: 'Automated Testing',
        image: "" + libDir + "/error.png"
      };
      message = "Test Failure\n\n" + failures + " out of " + testcount + " failed.\n\nPlease review console for details.";
      log.error(colorize("[bold]{Test Results:} [" + status + "]{" + (testcount - failures) + " of " + testcount + " passed.}"));
    } else {
      options = {
        title: 'Automated Testing',
        image: "" + libDir + "/success.png"
      };
      message = "All Tests Passed\n\n" + testcount + " test(s) completed.";
      log.info(colorize("[bold]{Test Results:} [" + status + "]{" + (testcount - failures) + " of " + testcount + " passed.}"));
    }
    growl.notify(message, options);
    failures = 0;
    return testcount = 0;
  };
  runTests = function(callback) {
    files = [];
    try {
      files = fs.readdirSync("" + specFileDir);
    } catch (err) {
      log.emergency("Failed to load tests in [bold]{" + specFileDir + "}\n");
      ++failures;
      process.exit(1);
    }
    files.forEach(runTestFile);
    return callback(null);
  };
  runTestFile = function(file) {
    var check, mod, title;
    require('sys').print(colorize("[purple]{\n=======================================================================================\n}"));
    log.notice(colorize("[purple]{" + file + "} being processed...."));
    if (file.match(file_matcher)) {
      title = path.basename(file);
      file = path.join("" + specFileDir, file);
      mod = require(file);
      (check = function() {
        var len;
        len = Object.keys(mod).length;
        if (len) {
          return runTestSuite(title, mod);
        } else {
          return setTimeout(check, 20);
        }
      })();
      return delete require.cache[file];
    }
  };
  runTestSuite = function(title, tests) {
    var finish, keys, next, setup, teardown;
    console.log("" + failures + " initial");
    unhook = hook_stdout(function(string, encoding, fd) {});
    keys = Object.keys(tests);
    setup = {};
    teardown = {};
    try {
      setup = tests['setup'];
      if (typeof setup === "function") {
        log.notice("!!!Suite contains setup, function completed successfully.");
        setup();
      }
    } catch (err) {
      log.error("!!!Suite setup failed\n\n " + err + "\n");
    }
    teardown = tests['teardown'];
    process.setMaxListeners(10 + process.listeners("beforeExit").length + keys.length);
    finish = function() {
      if (!requestCount) {
        try {
          if (typeof teardown === "function") {
            teardown();
            log.notice("!!!Teardown function completed successfully.");
          }
        } catch (err) {
          log.error("!!!Teardown function failed\n\n" + err + "\n");
        }
        unhook();
        return report(title);
      } else {
        return process.nextTick(finish);
      }
    };
    return (next = function() {
      var key, test;
      if (keys.length) {
        test = tests[key = keys.shift()];
        if (key === "setup" || key === "teardown") {
          return next();
        }
        testcount++;
        try {
          test(function() {
            console.log("!!!Testdone " + failures);
            return process.on("beforeExit", function() {});
          });
          return next();
        } catch (err) {
          failures++;
          return next();
        }
      } else {
        console.log("!!!finsihed " + failures);
        return finish();
      }
    })();
  };
  spec = function(filepath) {
    return async.series({
      gather_files: function(callback) {
        if (filepath === true) {
          filepath = "/";
        }
        filepath = path.join(prodSrcDir, path.normalize(filepath));
        return gatherFiles(filepath, /\.coffee/, function(err, results) {
          prodCoffeeFiles = results;
          return callback(err, results);
        });
      },
      create_specs: function(callback) {
        var file, index, pending, _len, _results;
        pending = prodCoffeeFiles.length;
        _results = [];
        for (index = 0, _len = prodCoffeeFiles.length; index < _len; index++) {
          file = prodCoffeeFiles[index];
          _results.push((function(file, index) {
            var specFile;
            specFile = path.join(specFileDir, path.basename(file, '.coffee') + ".spec.coffee");
            fs.stat(specFile, function(err, stats) {
              var prodFile;
              if (err) {
                prodFile = path.join(prodDeployDir, path.basename(file, '.coffee'));
                return writeSpecFile(specFile, prodFile, function(error, results) {
                  if (error) {
                    return callback(err, null);
                  }
                });
              }
            });
            if (!--pending) {
              return callback(null, null);
            }
          })(file, index));
        }
        return _results;
      }
    }, function(err, results) {
      if (err) {
        return handleError(err);
      }
    });
  };
  tester = function() {
    return async.series({
      compile_prod: function(callback) {
        if (config.noCompile === true) {
          return callback(null, null);
        } else {
          return gatherFiles(prodSrcDir, /\.coffee/, function(err, results) {
            var file, index, pending, _len, _results;
            prodCoffeeFiles = results;
            pending = prodCoffeeFiles.length;
            _results = [];
            for (index = 0, _len = prodCoffeeFiles.length; index < _len; index++) {
              file = prodCoffeeFiles[index];
              _results.push((function(file, index) {
                return exec("coffee --output " + prodDeployDir + " --compile " + file, function(err, stdout, stderr) {
                  if (!--pending) {
                    return callback(null, null);
                  }
                });
              })(file, index));
            }
            return _results;
          });
        }
      },
      create_specs: function(callback) {
        if (autoSpec === true) {
          spec("/");
        }
        return callback(null, null);
      },
      run_specs: function(callback) {
        return runTests(function(err) {
          intialTestComplete = true;
          return callback(err, null);
        });
      }
    });
  };
  unWatchCoffeeFile = function(err, file) {
    if (("" + file).match(/\.coffee/) != null) {
      util.warning("" + file + " removed.");
      fs.unwatchFile("" + file);
      return runTests(function(err) {});
    }
  };
  walk = function(dir, extRegex, callback) {
    var pending, results;
    results = [];
    pending = 0;
    return fs.readdir(dir, function(err, list) {
      var file, _i, _len, _results;
      if (err) {
        callback(err, null);
      }
      pending = list.length;
      _results = [];
      for (_i = 0, _len = list.length; _i < _len; _i++) {
        file = list[_i];
        _results.push((function(file) {
          file = dir + file;
          return fs.stat(file, function(err, stat) {
            if (stat && stat.isDirectory()) {
              file += "/";
              if (("" + file).match(/node_modules/) != null) {
                if (!--pending) {
                  return callback(null, results);
                }
              } else {
                return walk(file, extRegex, function(err, res) {
                  results = results.concat(res);
                  if (!--pending) {
                    return callback(null, results);
                  }
                });
              }
            } else {
              if (file.match(extRegex)) {
                results.push(file);
              }
              if (!--pending) {
                return callback(null, results);
              }
            }
          });
        })(file));
      }
      return _results;
    });
  };
  watchCoffeeFile = function(err, file) {
    if (!(("" + file).match(/\.spec\.coffee/) != null) && (("" + file).match(/\.coffee/) != null)) {
      log.notice("Watch added for " + colorize("[cyan]{" + file + "}"));
      fs.unwatchFile("" + file);
      return fs.watchFile("" + file, function(curr, prev) {
        if (+curr.mtime !== +prev.mtime) {
          log.notice("Saw change in " + colorize("[cyan]{" + file + "}"));
          if (!config.noCompile === true) {
            return exec("coffee --output " + prodDeployDir + " --compile " + file, function(err, stdout, stderr) {
              return runTests(function(err) {});
            });
          } else {
            return runTests(function(err) {});
          }
        }
      });
    } else if (("" + file).match(/\.spec\.coffee/)) {
      log.notice("Watch added for " + colorize("[cyan]{" + file + "}"));
      fs.unwatchFile("" + file);
      return fs.watchFile("" + file, function(curr, prev) {
        if (+curr.mtime !== +prev.mtime) {
          log.notice("Saw change in " + colorize("[cyan]{" + file + "}"));
          return runTests(function(err) {});
        }
      });
    }
  };
  writeSpecFile = function(specFile, prodFile, callback) {
    var libFile, specContent;
    libFile = path.basename(prodFile, path.extname(prodFile));
    specContent = ["replace with libfile", "assert = require('assert')", "module.exports =", "\t\"You need to modify this with real test cases and thus it fails until this file is modified.\": ->", "\t\tassert.ok false, \"it will fail\""];
    specContent[0] = "" + (libFile.replace(/\-/, "_")) + " = require('" + libFile + "')";
    return fs.writeFile(specFile, specContent.join('\n'), 'utf8', function(err) {
      log.notice("Created specfile '" + specFile + "'");
      return callback(err, null);
    });
  };
}).call(this);
